#include "grafo.h"

Grafo::Grafo(int numVert) {
  this->numVert = numVert;
  vec = new arista*[numVert];
  for (int i=0; i < numVert; i++) vec[i] = 0;
}
bool Grafo::existe_arista(int u, int v) const {
  for (const arista *r = vec[u]; r != 0; r = r->sig)
    if (r->vertice_destino == v) return true;
  return false;
}
void Grafo::insertar_arista(int u, int v, unsigned int p, bool nueva) {
  if (nueva || !existe_arista(u,v))
    vec[u] = new arista(v,p,vec[u]);
  //else std::cout << "repetidas!!\n";
}
void Grafo::imprime(/*ostream &s*/) const {
  for (int i=0; i < numVert; i++) {
    cout << i << ":";
    for (const arista *r = vec[i]; r != 0; r = r->sig) {
      if (r != vec[i]) cout << ",";
      cout << "(" << r->vertice_destino << "," << r->peso << ")";
    }
    cout << endl;
  }
}

void Grafo::dijkstra(int origen, unsigned int *D, int *S){
  const unsigned int infinito = 1000000;
  //int *D = new int[numVert];
  //bool  *S = new  bool[numVert];
  //int *Pred = new int[numVert];
  for (int i=0;i<numVert;++i){
    D[i]    = infinito;
    //S[i]    = false; // no seleccionado
    //Pred[i] = -1;
  }
  D[origen] = 0;
  for (int iteraciones = 0; iteraciones<numVert; iteraciones++) {
    // buscar menor valor D de un vertice NO seleccionado
    unsigned int menor = infinito;
    int quien_menor = -1;
    for (int i=0;i<numVert;++i) 
      if (S[i]!=origen && D[i]<menor) {
	menor = D[i];
	quien_menor = i;
      }
    // ya conocemos el menor
    if (quien_menor == -1) break;
    S[quien_menor] = origen;
    for (arista *p=vec[quien_menor]; p!=0; p=p->sig) {
      if (S[p->vertice_destino]!=origen && D[quien_menor]+p->peso < D[p->vertice_destino]){
	D[p->vertice_destino]    = D[quien_menor]+p->peso;
        //Pred[p->destino] = quien_menor;
      }
    }
  }
  
  //delete[] D;
  //delete[] S;
  //return max;
}
