#include "heap.h"

max_heap::max_heap(int tamanyo_maximo) {                 // constructor
  tamanyo = (tamanyo_maximo > 0) ? tamanyo_maximo : 1;
  ocupados = 0;
  dist *rv = new dist[tamanyo];              // queremos empezar con indice 1
  vector = rv - 1;                            // vector[1] es rv[0],...
}

max_heap::~max_heap(){
  delete[] (vector+1);
}

int max_heap::maximo() {
  return vector[1].distancia;
}

void max_heap::heapify(int pos) {                  // versi´n iterativa
  int hijo;
  dist tmp = vector[pos];
  while (hijo_izq(pos) <= ocupados) {
    hijo = hijo_izq(pos);
    if(hijo < ocupados && (vector[hijo+1].distancia > vector[hijo].distancia || (vector[hijo+1].distancia == vector[hijo].distancia && vector[hijo+1].destino > vector[hijo].destino)))
      hijo++;                                        // el hijo derecho

    if(vector[hijo].distancia > tmp.distancia)
      vector[pos] = vector[hijo];
    else
      break;
    pos = hijo;
  }
  vector[ pos ] = tmp;
}


void max_heap::buildheap() {
  for (int i = ocupados/2; i >= 1; i--)
    heapify(i);
}

bool max_heap::extraer_maximo(dist& elemento) {
  if (ocupados <= 0)
    return false;
  elemento = vector[1];
  vector[1] = vector[ocupados];
  ocupados--;
  heapify(1);
  return true;
}

bool max_heap::insertar(unsigned int elemento, int ini, int des) {
  if (ocupados >= tamanyo)
    return false;
  ocupados++;
  int posicion = ocupados;
  while ((posicion > 1) && (elemento > vector[padre(posicion)].distancia)) {
    vector[posicion] = vector[padre(posicion)];
    posicion = padre(posicion);
  }
  vector[posicion].distancia = elemento;
  vector[posicion].inicio = ini;
  vector[posicion].destino = des;
  return true;
}

void max_heap::meter(unsigned int elemento, int ini, int des){
  vector[1].distancia=elemento;
  vector[1].inicio = ini;
  vector[1].destino = des;
  heapify(1);
}

/*
void max_heap::heapsort() {
  int hay = ocupados;    // para saber tama%GË%@o del vector al finalizar
  buildheap();                                          // coste O(n)
  for (int i = ocupados; i > 1; i--) {               // intercambiar:
    int tmp = vector[1]; vector[1] = vector[i]; vector[i] = tmp;
    ocupados--;       // eliminar ´ltimo del heap, se queda en vector
    heapify(1);     // restaurar propiedad heap bajando 1er elemento
  }                       // al finalizar, el vector YA NO es un heap
  ocupados = hay;                    // restauramos atributo ocupados
}
*/


void max_heap::imprime(){
  for(int i=1;i<=ocupados;++i){
    std::cout << "Destino: " << vector[i].destino << " Distancia: " << vector[i].distancia << std::endl;
  }
  std::cout << "\n\n";
}
