//#include <iostream>
//#include <fstream>
#include <string>
#include <time.h>
#include <stdlib.h>
#include "patch.h"
#include "heap.h"
#include "grafo.h"

using namespace std;

int numImagenes(char *nombre_fich){
  ifstream fich(nombre_fich);
  char buffer[50];
  int n=0;
  while(fich.getline(buffer, 50)) n++;
  return n;
}

int main(int argc, char **argv){

  //cout << "Voy a ganar este concurso!!!" << endl;
  if(argc!=5){
    cout << argv[0] << " Fich_imagenes k w c" << endl;
    return 0;
  }
  
  clock_t ini=clock();
  
  int k=atoi(argv[2]), w=atoi(argv[3]), c=atoi(argv[4]);
  int n_imagenes = numImagenes(argv[1]);
  char **ficheros_imagenes = new char*[n_imagenes];
  for(int i=0;i<n_imagenes;++i) ficheros_imagenes[i] = new char[30];
  ifstream fich(argv[1]);
  for(int i=0;i<n_imagenes;++i) fich.getline(ficheros_imagenes[i],30);
  fich.close();
  Image *imagenes = new Image[n_imagenes];
  
  for(int i=0;i<n_imagenes;++i){
    ifstream fich(ficheros_imagenes[i]);
    imagenes[i].constructor(fich, w, c);
    fich.close();
  }
  
  //cout << "\ntiempo construir patch's: " << (clock()-ini)/((double)(CLOCKS_PER_SEC)) << endl;
  
  ini=clock();
  for(int i=0;i<n_imagenes;++i){
    imagenes[i].vector_dist(n_imagenes);
  }
  //cout << "tiempo inicializar vector distancias: " << (clock()-ini)/((double)(CLOCKS_PER_SEC)) << endl;
  
  
  ini = clock();
  
  max_heap H(k);
  Grafo grafo(n_imagenes);
  
  dist dis;
  for(int i=0;i<n_imagenes;++i){       // recorremos todas las imágenes para calcular las distancias con las demás imágenes
    
    for(int k=0;k<i;++k){
      if(!H.lleno()) H.insertar(imagenes[k].distancias[i], i, k);
      else{
	if(imagenes[k].distancias[i] < H.maximo()) H.meter(imagenes[k].distancias[i], i, k);
      }
    }
    
    for(int j=i+1;j<n_imagenes;++j){   // recorremos las imágenes restantes para cada imagen
      
      
      
      int tableSize = imagenes[i].tabla->getSize();
      for(int k=0;k<tableSize;++k){                 // recorremos la hash de la imagen i
	Patch *aux=imagenes[i].tabla->table[k];
	while(aux){
	  int count;
	  if(imagenes[j].buscar(aux, &count, i)){
	    if(aux->cont > count){
	      imagenes[i].distancias[j]+=(aux->cont - count);
	      //imagenes[j].distancias[i]+=(aux->cont - count);
	    }
	    else{
	      imagenes[i].distancias[j]+=(count - aux->cont);
	      //imagenes[j].distancias[i]+=(count - aux->cont);
	    }
	  }
	  else{
	    imagenes[i].distancias[j]+=aux->cont;
	    //imagenes[j].distancias[i]+=aux->cont;
	  }
	  aux=aux->next;
	}
      }
      
      for(int k=0;k<tableSize;++k){     // recorremos la hash de la imagen j para sumar los patch que faltan
	Patch *aux=imagenes[j].tabla->table[k];
	while(aux){
	  if(aux->visitado != i){
	    imagenes[i].distancias[j]+=aux->cont;
	    //imagenes[j].distancias[i]+=aux->cont;
	  }
	  aux=aux->next;
	}
      }
      if(!H.lleno()) H.insertar(imagenes[i].distancias[j], i, j);
      else{
	if(imagenes[i].distancias[j] < H.maximo()) H.meter(imagenes[i].distancias[j], i, j);
      }
      
    }
    while(!H.vacio()){
      H.extraer_maximo(dis);
      grafo.insertar_arista(dis.inicio, dis.destino, dis.distancia);
      grafo.insertar_arista(dis.destino, dis.inicio, dis.distancia);
      
      //cout << dis.inicio << " -> " << dis.destino << " = " << dis.distancia << endl;
    }
    //H.vaciar();
  }
  /*for(int k=0;k<n_imagenes-1;++k){
    if(!H.lleno()) H.insertar(imagenes[k].distancias[n_imagenes-1], n_imagenes-1, k);
    else{
      if(imagenes[k].distancias[n_imagenes-1] < H.maximo()) H.meter(imagenes[k].distancias[n_imagenes-1], n_imagenes-1, k);
    }
  }
  while(!H.vacio()){
    H.extraer_maximo(dis);
    grafo.insertar_arista(dis.inicio, dis.destino, dis.distancia);
    grafo.insertar_arista(dis.destino, dis.inicio, dis.distancia);
    //cout << dis.inicio << " -> " << dis.destino << " = " << dis.distancia << endl;
  }
  */
  //cout << "tiempo calcular distancias y crear grafo: " << (clock()-ini)/((double)(CLOCKS_PER_SEC)) << endl << endl;
  
  
  /*for(int i=0;i<n_imagenes;++i){
    for(int j=0;j<n_imagenes;++j)
      //if(imagenes[i].distancias[j] < 8000 && imagenes[i].distancias[j] != 0) cout << i << " -> " << j << " = " << imagenes[i].distancias[j] << endl;
      //cout << imagenes[i].distancias[j] << " ";
      //if(i==205) cout << imagenes[i].distancias[j] << " ";
      cout << imagenes[i].distancias[j] << " ";
    cout << endl;
  }*/

  //grafo.imprime();
  
  //cout << "\n\n\n";
  
  ini = clock();
  int *S=new int[n_imagenes];
  
  for(int i=0;i<n_imagenes;++i)
    S[i]=-1;

  for(int i=0;i<n_imagenes;++i){
    grafo.dijkstra(i, imagenes[i].distancias, S);
    for(int k=0;k<n_imagenes;++k){
      if(imagenes[i].distancias[k] == 1000000) cout << "inf ";
      else cout << imagenes[i].distancias[k] << " ";
    }
    cout << endl;
  }
  
  //cout << "tiempo en calcular caminos minimos (dijkstra): " << (clock()-ini)/((double)(CLOCKS_PER_SEC)) << endl;
  
  
  
  return 0;
}
