//#include <iostream>
//#include <fstream>
#include <string>
#include <time.h>
#include <stdlib.h>
#include "patch.h"
#include "heap.h"
#include "grafo.h"

using namespace std;

int numImagenes(char *nombre_fich){
  ifstream fich(nombre_fich);
  char buffer[50];
  int n=0;
  while(fich.getline(buffer, 50)) n++;
  return n;
}

int main(int argc, char **argv){

  
  if(argc!=5){
    cout << argv[0] << " Fich_imagenes k w c" << endl;
    return 0;
  }
  
  clock_t ini=clock();
  
  int k=atoi(argv[2]), w=atoi(argv[3]), c=atoi(argv[4]);
  int n_imagenes = numImagenes(argv[1]);
  char **ficheros_imagenes = new char*[n_imagenes];
  for(int i=0;i<n_imagenes;++i) ficheros_imagenes[i] = new char[30];
  ifstream fich(argv[1]);
  for(int i=0;i<n_imagenes;++i) fich.getline(ficheros_imagenes[i],30);
  fich.close();
  int size_hash = 524288;
  Image *imagenes = new Image[n_imagenes];
  hash *tabla_hash = new hash(size_hash);
  
  queue <int> cola;
  
  for(int i=0;i<n_imagenes;++i){
    ifstream fich(ficheros_imagenes[i]);
    imagenes[i].constructor(fich, w, c, tabla_hash, i, n_imagenes, cola);
    fich.close();
  }
  //cout << "\ntiempo construir patch's: " << (clock()-ini)/((double)(CLOCKS_PER_SEC)) << endl;
  
  ini=clock();
  for(int i=0;i<n_imagenes;++i){
    imagenes[i].vector_dist(n_imagenes);
  }
  for(int i=0;i<n_imagenes;++i){
    for(int j=i+1;j<n_imagenes;++j){
      imagenes[i].distancias[j] = imagenes[i].suma + imagenes[j].suma;
    }
  }
  //cout << "tiempo inicializar vector distancias: " << (clock()-ini)/((double)(CLOCKS_PER_SEC)) << endl;
  
  
  ini = clock();
  
  max_heap H(k);
  Grafo grafo(n_imagenes);
  
  dist dis;

  /*for(int k=0;k<size_hash;++k){
    Patch *aux=tabla_hash->table[k];
    while(aux){
      for(int i=0;i<n_imagenes;++i){
	for(int j=i+1;j<n_imagenes;++j){
	  if(aux->contador[j]>0){
	    if(aux->contador[i] > aux->contador[j]) imagenes[i].distancias[j]+=(aux->contador[i] - aux->contador[j]);
	    else imagenes[i].distancias[j]+=(aux->contador[j] - aux->contador[i]);
	  }
	  else imagenes[i].distancias[j]+=aux->contador[i];
	}
      }
      aux=aux->next;
    }
  }*/

  /*for(int i=0;i<size_hash;++i){
    //cout << i << endl;
    Patch *aux=tabla_hash->table[i];
    while(aux){
      nodo_contador *aux2=aux->contador;
      while(aux2){
        cout << "(" << aux->r << "," << aux->g << "," << aux->b;
        cout << ") -> imagen: " << aux2->imagen << ", repetidos: " << aux2->cont << endl;
        aux2=aux2->next;
      }
      aux=aux->next;
    }
  }*/

  /*for(int k=0;k<size_hash;++k){
    Patch *aux=tabla_hash->table[k];
    while(aux){
      bool nuevo=true, primero;
      for(nodo_contador *nodo_aux_i = aux->contador; nodo_aux_i ; nodo_aux_i = nodo_aux_i->next){
        int contador_imagen=n_imagenes-1;
        primero=true;
    	for(nodo_contador *nodo_aux_j = nodo_aux_i; nodo_aux_j ; nodo_aux_j = nodo_aux_j->next){
          //cout << "0-1: " << imagenes[0].distancias[1] << endl;
          //cout << "0-2: " << imagenes[0].distancias[2] << endl;
          //cout << "1-2: " << imagenes[1].distancias[2] << endl << endl;
          if(!nuevo && primero) contador_imagen = nodo_aux_i->imagen;
	  while(contador_imagen > nodo_aux_j->imagen){
            imagenes[nodo_aux_j->imagen].distancias[contador_imagen]+=nodo_aux_j->cont;
	    contador_imagen--;
	  }
          if(nodo_aux_i->imagen != nodo_aux_j->imagen){
	    if(nodo_aux_i->cont > nodo_aux_j->cont) imagenes[nodo_aux_j->imagen].distancias[nodo_aux_i->imagen]+=(nodo_aux_i->cont - nodo_aux_j->cont);
	    else imagenes[nodo_aux_j->imagen].distancias[nodo_aux_i->imagen]+=(nodo_aux_j->cont - nodo_aux_i->cont);
	  }
	  contador_imagen--;
          while(nodo_aux_j->next == 0 && contador_imagen!=-1){
            imagenes[contador_imagen].distancias[nodo_aux_i->imagen]+=nodo_aux_i->cont;
	    contador_imagen--;
          }
          primero=false;
        }
      nuevo=false;
      }
      aux=aux->next;
    }
  }*/


  while(!cola.empty()){
    int pos = cola.front();
    cola.pop();
    Patch *aux=tabla_hash->table[pos];
    while(aux){
      nodo_contador *nodo_i = aux->contador;
      while(nodo_i){
        nodo_contador *nodo_j = nodo_i->next;
        while(nodo_j){
          if(nodo_i->cont < nodo_j->cont) imagenes[nodo_j->imagen].distancias[nodo_i->imagen]-=(nodo_i->cont << 1);
          else imagenes[nodo_j->imagen].distancias[nodo_i->imagen]-=(nodo_j->cont << 1);
          nodo_j = nodo_j->next;
        }
        nodo_i = nodo_i->next;
      }
      aux=aux->next;
    }
  }

  //for(int k=0;k<size_hash;++k){
  /*while(!cola.empty()){
    int pos = cola.front();
    cola.pop();
    Patch *aux=tabla_hash->table[pos];
    //Patch *aux=tabla_hash->table[k];
    while(aux){
      //cout << "(" << aux->r << ", " << aux->g << ", " << aux->b << ")" << endl;
      nodo_contador *nodo_i = aux->contador;
      for(int i=n_imagenes-1;i>0;--i){
	//if(nodo_i->imagen == 0) break;
	if(nodo_i && i!=nodo_i->imagen){
	  nodo_contador *nodo_j = nodo_i;
	  //cout << "i != nodo_i->imagen" << endl;
	  while(nodo_j){
	    imagenes[nodo_j->imagen].distancias[i]+=nodo_j->cont;
	    nodo_j = nodo_j->next;
	  }
	}
	else if(nodo_i && i == nodo_i->imagen){
	  nodo_contador *nodo_j = nodo_i->next;
	  int contador_imagen = nodo_i->imagen-1;
	  while(nodo_j){
	    /*if(nodo_j->next == 0){
	      cout << "nodo_j->next == 0" << endl;
	      cout << aux->r << ", " << aux->g << ", " << aux->b << endl;
	      cout << "nodo_i: " << nodo_i->imagen << ", " << nodo_i->cont << endl;
	      cout << "nodo_i->next: " << nodo_i->next->imagen << ", " << nodo_i->cont << endl;
	      cout << "nodo_j: " << nodo_j->imagen << ", " << nodo_j->cont << endl;
	      while(contador_imagen != -1){
		cout << "contador_imagen: " << contador_imagen << endl;
		imagenes[contador_imagen].distancias[nodo_i->imagen]+=nodo_i->cont;
		contador_imagen--;
	      }
	      break;
	    }*//*
	    //else{
	    //cout << "pruebas" << endl;
	      while(contador_imagen > nodo_j->imagen){
		//cout << contador_imagen << ", " << nodo_j->imagen << endl;
		imagenes[contador_imagen].distancias[nodo_i->imagen]+=nodo_i->cont;
		contador_imagen--;
	      }
	      if(nodo_i->cont > nodo_j->cont) imagenes[nodo_j->imagen].distancias[nodo_i->imagen]+=(nodo_i->cont - nodo_j->cont);
	      else imagenes[nodo_j->imagen].distancias[nodo_i->imagen]+=(nodo_j->cont - nodo_i->cont);
	      contador_imagen--;
	      if(nodo_j->next == 0){
		if(nodo_i->next == 0) contador_imagen++;
		while(contador_imagen >= 0){
		  imagenes[contador_imagen].distancias[nodo_i->imagen]+=nodo_i->cont;
		  contador_imagen--;
		}
		//break;
	      }
	      //cout << "contador_imagen: " << contador_imagen << endl;
	      nodo_j = nodo_j->next;
	      //}
	  }
	  if(nodo_j == 0){
	    while(contador_imagen >= 0){
	      imagenes[contador_imagen].distancias[nodo_i->imagen]+=nodo_i->cont;
	      contador_imagen--;
	    }
	  }
	  nodo_i = nodo_i->next;
	}
	//cout << "0-1: " << imagenes[0].distancias[1] << endl;
	//cout << "0-2: " << imagenes[0].distancias[2] << endl;
	//cout << "1-2: " << imagenes[1].distancias[2] << endl << endl;
      }
      aux = aux->next;
    }
  }*/

  /*for(int i=0;i<n_imagenes;++i){
    for(int j=0;j<n_imagenes;++j)
      //if(imagenes[i].distancias[j] < 8000 && imagenes[i].distancias[j] != 0) cout << i << " -> " << j << " = " << imagenes[i].distancias[j] << endl;
      //cout << imagenes[i].distancias[j] << " ";
      //if(i==205) cout << imagenes[i].distancias[j] << " ";
      cout << imagenes[i].distancias[j] << " ";
    cout << endl;
  }*/


  for(int i=0;i<n_imagenes;++i){
    for(int k=0;k<i;++k){
      if(H.insertar(imagenes[k].distancias[i],i,k));
      else if(imagenes[k].distancias[i] < H.maximo()) H.meter(imagenes[k].distancias[i],i,k);
    }
    for(int j=i+1;j<n_imagenes;++j){
      if(H.insertar(imagenes[i].distancias[j],i,j));
      else if(imagenes[i].distancias[j] < H.maximo()) H.meter(imagenes[i].distancias[j], i, j);
    }
    while(!H.vacio()){
      H.extraer_maximo(dis);
      grafo.insertar_arista(dis.inicio, dis.destino, dis.distancia);
      grafo.insertar_arista(dis.destino, dis.inicio, dis.distancia);
    }
  }
  
  /*for(int i=0;i<n_imagenes;++i){       // recorremos todas las imágenes para calcular las distancias con las demás imágenes
    
    for(int k=0;k<i;++k){
      if(!H.lleno()) H.insertar(imagenes[k].distancias[i], i, k);
      else{
	if(imagenes[k].distancias[i] < H.maximo()) H.meter(imagenes[k].distancias[i], i, k);
      }
    }
    
    for(int j=i+1;j<n_imagenes;++j){   // recorremos las imágenes restantes para cada imagen
      int tableSize = imagenes[i].tabla->getSize();
      for(int k=0;k<tableSize;++k){                 // recorremos la hash de la imagen i
	Patch *aux=imagenes[i].tabla->table[k];
	while(aux){
	  int count;
	  if(imagenes[j].buscar(aux, &count, i)){
	    if(aux->cont > count){
	      imagenes[i].distancias[j]+=(aux->cont - count);
	      //imagenes[j].distancias[i]+=(aux->cont - count);
	    }
	    else{
	      imagenes[i].distancias[j]+=(count - aux->cont);
	      //imagenes[j].distancias[i]+=(count - aux->cont);
	    }
	  }
	  else{
	    imagenes[i].distancias[j]+=aux->cont;
	    //imagenes[j].distancias[i]+=aux->cont;
	  }
	  aux=aux->next;
	}
      }
      for(int k=0;k<tableSize;++k){     // recorremos la hash de la imagen j para sumar los patch que faltan
	Patch *aux=imagenes[j].tabla->table[k];
	while(aux){
	  if(aux->visitado != i){
	    imagenes[i].distancias[j]+=aux->cont;
	    //imagenes[j].distancias[i]+=aux->cont;
	  }
	  aux=aux->next;
	}
      }
      if(!H.lleno()) H.insertar(imagenes[i].distancias[j], i, j);
      else{
	if(imagenes[i].distancias[j] < H.maximo()) H.meter(imagenes[i].distancias[j], i, j);
      }
    }
    while(!H.vacio()){
      H.extraer_maximo(dis);
      grafo.insertar_arista(dis.inicio, dis.destino, dis.distancia);
      grafo.insertar_arista(dis.destino, dis.inicio, dis.distancia);
      
      //cout << dis.inicio << " -> " << dis.destino << " = " << dis.distancia << endl;
    }
  }*/

  //cout << "tiempo calcular distancias y crear grafo: " << (clock()-ini)/((double)(CLOCKS_PER_SEC)) << endl << endl;
  
  
  /*for(int i=0;i<n_imagenes;++i){
    for(int j=0;j<n_imagenes;++j)
      //if(imagenes[i].distancias[j] < 8000 && imagenes[i].distancias[j] != 0) cout << i << " -> " << j << " = " << imagenes[i].distancias[j] << endl;
      //cout << imagenes[i].distancias[j] << " ";
      //if(i==205) cout << imagenes[i].distancias[j] << " ";
      cout << imagenes[i].distancias[j] << " ";
    cout << endl;
  }*/

  //grafo.imprime();
  
  //cout << "\n\n\n";
  ini = clock();
  int *S=new int[n_imagenes];
  
  for(int i=0;i<n_imagenes;++i)
    S[i]=-1;

  for(int i=0;i<n_imagenes;++i){
    grafo.dijkstra(i, imagenes[i].distancias, S);
    for(int k=0;k<n_imagenes;++k){
      if(imagenes[i].distancias[k] == 1000000) cout << "inf ";
      else cout << imagenes[i].distancias[k] << " ";
    }
    cout << endl;
  }
  
  //cout << "tiempo en calcular caminos minimos (dijkstra): " << (clock()-ini)/((double)(CLOCKS_PER_SEC)) << endl;
  
  
  
  return 0;
}
