#include "grafo.h"

Grafo::Grafo(int numVert) {
  this->numVert = numVert;
  vec = new arista*[numVert];
  for (int i=0; i < numVert; i++) vec[i] = 0;
}
bool Grafo::existe_arista(int u, int v) const {
  for (const arista *r = vec[u]; r != 0; r = r->sig)
    if (r->vertice_destino == v) return true;
  return false;
}
void Grafo::insertar_arista(int u, int v, unsigned int p, bool nueva) {
  if (nueva || !existe_arista(u,v))
    vec[u] = new arista(v,p,vec[u]);
}
void Grafo::imprime(/*ostream &s*/) const {
  for (int i=0; i < numVert; i++) {
    cout << i << ":";
    for (const arista *r = vec[i]; r != 0; r = r->sig) {
      if (r != vec[i]) cout << ",";
      cout << "(" << r->vertice_destino << "," << r->peso << ")";
    }
    cout << endl;
  }
}


void Grafo::dijkstra(int origen, unsigned int *D, int *S){
  const unsigned int infinito = 1000000;
  min_heap heap(901);
  for (int i=0;i<numVert;++i)
    D[i]    = infinito;
  D[origen] = 0;
  heap.insertar(D[origen],origen);
  
  int menor;
  int quien_menor;
  while(!heap.vacio()){
    // buscar menor valor D de un vertice NO seleccionado
    heap.extraer_minimo(menor, quien_menor);
    // ya conocemos el menor
    S[quien_menor] = origen;
    for (arista *p=vec[quien_menor]; p!=0; p=p->sig){
      if (S[p->vertice_destino]!=origen && D[quien_menor]+p->peso < D[p->vertice_destino]){
	D[p->vertice_destino]    = D[quien_menor]+p->peso;
        heap.insertar(D[p->vertice_destino], p->vertice_destino);
        heap.actualizar(D[p->vertice_destino], p->vertice_destino);
      }
    }
  }
}
