#ifndef HEAP_H
#define HEAP_H

#include <iostream>

struct dist{
  unsigned int distancia;
  int inicio, destino;
};

struct int_dijkstra{
  int pos, indice;
};

class max_heap {     // maxheap binario de valores de tipo T comparables
  dist *vector;                         // vector que empieza con indice 1
  int tamanyo,ocupados;
  int padre(int pos) { return pos/2; }                    // estas tres
  int hijo_izq(int pos) { return 2*pos; }                 // funciones
  int hijo_der(int pos) { return 2*pos+1; }               // son inline
 public:
  max_heap(int tamanyo_maximo);                          // constructor
  ~max_heap();                                           // destructor
  void vaciar() { ocupados = 0; }
  bool vacio() const { return ocupados == 0; }
  bool lleno() const { return ocupados == tamanyo; }
  int ocupacion() const { return ocupados; }
  int maximo();
  void heapify(int pos);
  bool extraer_maximo(dist& elemento);                   // extrae y borra
  bool insertar(unsigned int elemento, int ini, int des);         // "true" si se ha podido insertar
  void meter(unsigned int elemento, int ini, int des);
  void buildheap();           // se usa para imponer propiedad de orden

  void imprime();
  
};




//--------------------MIN_HEAP--------------------------//


class min_heap {     // maxheap binario de valores de tipo T comparables
  int_dijkstra *vector;                         // vector que empieza con indice 1
  int *indice;
  int tamanyo,ocupados;
  int padre(int pos) { return pos/2; }                    // estas tres
  int hijo_izq(int pos) { return 2*pos; }                 // funciones
  int hijo_der(int pos) { return 2*pos+1; }               // son inline
 public:
  min_heap(int tamanyo_maximo);                          // constructor
  ~min_heap();                                           // destructor
  void vaciar() { ocupados = 0; }
  bool vacio() const { return ocupados == 0; }
  bool lleno() const { return ocupados == tamanyo; }
  int ocupacion() const { return ocupados; }
  void heapify(int pos);
  void actualizar(int valor_nuevo, int index);
  bool extraer_minimo(int &elemento, int &index);                   // extrae y borra
  bool insertar(int elemento, int index);         // "true" si se ha podido insertar

  void imprime();
  
};

#endif //HEAP_H
