#include <string>
#include <time.h>
#include <stdlib.h>
#include "patch.h"
#include "heap.h"
#include "grafo.h"
#include <algorithm>

using namespace std;

int numImagenes(char *nombre_fich){
  ifstream fich(nombre_fich);
  char buffer[50];
  int n=0;
  while(fich.getline(buffer, 50)) n++;
  return n;
}

int main(int argc, char **argv){
  if(argc!=5){
    cout << argv[0] << " Fich_imagenes k w c" << endl;
    return 0;
  }
  
  clock_t ini=clock();
  
  int k=3/*atoi(argv[2])*/, w=5/*=atoi(argv[3])*/, c=64/*=atoi(argv[4])*/;
  int n_imagenes = 900;//numImagenes(argv[1]);
  char **ficheros_imagenes = new char*[n_imagenes];
  for(int i=0;i<n_imagenes;++i) ficheros_imagenes[i] = new char[30];
  ifstream fich(argv[1]);
  for(int i=0;i<n_imagenes;++i) fich.getline(ficheros_imagenes[i],30);
  fich.close();
  int size_hash = 524288;  //512k
  Image *imagenes = new Image[n_imagenes];
  hash *tabla_hash = new hash(size_hash);
  
  queue <int> cola;
  
  for(int i=0;i<n_imagenes;++i){
    ifstream fich(ficheros_imagenes[i]);
    imagenes[i].constructor(fich, w, c, tabla_hash, i, n_imagenes, cola);
    fich.close();
  }
  
  ini=clock();
  for(int i=0;i<n_imagenes;++i){
    imagenes[i].vector_dist(n_imagenes);
  }
  for(int i=0;i<n_imagenes;++i){
    for(int j=i+1;j<n_imagenes;++j){
      imagenes[i].distancias[j] = imagenes[i].suma + imagenes[j].suma;
    }
  }
  
 
  ini = clock();
  
  max_heap H(k);
  Grafo grafo(n_imagenes);
  
  dist dis;

  //CÁLCULO DE DISTANCIAS
  
  while(!cola.empty()){
    int pos = cola.front();
    cola.pop();
    Patch *aux=tabla_hash->table[pos];
    while(aux){
      nodo_contador *nodo_i = aux->contador;
      while(nodo_i){
        nodo_contador *nodo_j = nodo_i->next;
        while(nodo_j){
          if(nodo_i->cont < nodo_j->cont) imagenes[nodo_j->imagen].distancias[nodo_i->imagen]-=(nodo_i->cont << 1);
          else imagenes[nodo_j->imagen].distancias[nodo_i->imagen]-=(nodo_j->cont << 1);
          nodo_j = nodo_j->next;
        }
        nodo_i = nodo_i->next;
      }
      aux=aux->next;
    }
  }


  for(int i=0;i<n_imagenes;++i){
    for(int k=0;k<i;++k){
      if(H.insertar(imagenes[k].distancias[i],i,k));
      else if(imagenes[k].distancias[i] < H.maximo()) H.meter(imagenes[k].distancias[i],i,k);
    }
    for(int j=i+1;j<n_imagenes;++j){
      if(H.insertar(imagenes[i].distancias[j],i,j));
      else if(imagenes[i].distancias[j] < H.maximo()) H.meter(imagenes[i].distancias[j], i, j);
    }
    while(!H.vacio()){
      H.extraer_maximo(dis);
      grafo.insertar_arista(dis.inicio, dis.destino, dis.distancia);
      grafo.insertar_arista(dis.destino, dis.inicio, dis.distancia);
    }
  }
  
  ini = clock();
  int *S=new int[n_imagenes];
  
  for(int i=0;i<n_imagenes;++i)
    S[i]=-1;

  // CÁLCULO DE CAMINOS MÍNIMOS

  for(int i=0;i<n_imagenes;++i){
    grafo.dijkstra(i, imagenes[i].distancias, S);
    for(int k=0;k<n_imagenes;++k){
      if(imagenes[i].distancias[k] == 1000000) cout << "inf ";
      else cout << imagenes[i].distancias[k] << " ";
    }
    cout << endl;
  }
    
  return 0;
}
