#include "patch.h"

Patch::Patch(){
  r=g=b=0;
  next=0;
}

//---------------Image---------------//

Image::Image(){}
Image::~Image(){}

void Image::leer_fichero(std::ifstream &fich_in, int w, int C){
  char buffer[5];
 
  fich_in >> buffer;
  fich_in >> c;
  fich_in >> f;
  fich_in >> buffer;
  int wh=c*3*f;
  vector = new unsigned int[wh];
  
  for(int i=0;i<wh;++i){
    fich_in >> vector[i];
    vector[i]/=C;
  }
}

void Image::crear_patchs(int w){

int alto=(f-w+1), ancho=(c-w+1), pos_izq, pos_der, i, j, ki, kj;
  n_patch=alto*ancho;
  datas = new Patch[n_patch]; // creo el vector de patch'es
  for(i=0;i<alto;++i){
    for(j=0;j<ancho;++j){
      pos_izq = i*ancho+j;
      for(ki=0;ki<w;++ki){
          pos_der = (i+ki)*c*3+j*3;
          (datas+pos_izq)->r+=*(vector+pos_der);
          (datas+pos_izq)->g+=*(vector+pos_der+1);
          (datas+pos_izq)->b+=*(vector+pos_der+2);
          (datas+pos_izq)->r+=*(vector+pos_der+3);
          (datas+pos_izq)->g+=*(vector+pos_der+4);
          (datas+pos_izq)->b+=*(vector+pos_der+5);
          (datas+pos_izq)->r+=*(vector+pos_der+6);
          (datas+pos_izq)->g+=*(vector+pos_der+7);
          (datas+pos_izq)->b+=*(vector+pos_der+8);
          (datas+pos_izq)->r+=*(vector+pos_der+9);
          (datas+pos_izq)->g+=*(vector+pos_der+10);
          (datas+pos_izq)->b+=*(vector+pos_der+11);
          (datas+pos_izq)->r+=*(vector+pos_der+12);
          (datas+pos_izq)->g+=*(vector+pos_der+13);
          (datas+pos_izq)->b+=*(vector+pos_der+14);
      }
    }
  }
  delete [] vector;  
}

void Image::constructor(std::ifstream &fich_in, int w, int C, hash *tabla, int indice, int n_imagenes, queue <int> &cola){
  suma=0;
  leer_fichero(fich_in, w, C);  
  crear_patchs(w);
  insertar_hash(tabla, indice, n_imagenes, cola, suma);
}

void Image::insertar_hash(hash *tabla, int indice, int n_imagenes, queue <int> &cola, int &suma){
  for(int i=0;i<n_patch;++i)
    tabla->insertar(&datas[i], indice, n_imagenes, cola, suma);
  delete [] datas;
}

void Image::vector_dist(int n_imagenes){
  distancias = new unsigned int[n_imagenes];
  for(int i=0;i<n_imagenes;++i)
    distancias[i]=0;
}

//-------------------TablaHash-------------------//

hash::hash(int size){
  tableSize = size;
  num_patch = new Patch[240000];
  num_nodos_patch = new nodo_contador[2400000];
  cuenta_patch=0;
  cuenta_nodos_patch=0;
  table = new Patch*[tableSize];
  for(int i=0;i<tableSize;++i) table[i]=0;
}

hash::~hash(){}

void hash::insertar(Patch *patch, int indice, int n_imagenes, queue <int> &cola, int &suma){
  unsigned int hash_func = DJBHash(patch);
  unsigned int hash_pos = hash_func & 524287;
  bool seguir=1;
  if(table[hash_pos]==0){
    num_patch[cuenta_patch].r = patch->r;
    num_patch[cuenta_patch].g = patch->g;
    num_patch[cuenta_patch].b = patch->b;
    num_nodos_patch[cuenta_nodos_patch].cont=1;
    num_nodos_patch[cuenta_nodos_patch].imagen=indice;
    num_nodos_patch[cuenta_nodos_patch].next=0;
    num_patch[cuenta_patch].contador = &num_nodos_patch[cuenta_nodos_patch];
    table[hash_pos] = &num_patch[cuenta_patch];
    ++cuenta_patch;
    ++cuenta_nodos_patch;
    cola.push(hash_pos);
    ++suma;
  }
  else{
    Patch *aux = table[hash_pos];
    while(aux && seguir){
      if(patch->r == aux->r && patch->g == aux->g && patch->b == aux->b){
	if(aux->contador->imagen == indice){++(aux->contador->cont); ++suma;}
	else{
	  num_nodos_patch[cuenta_nodos_patch].imagen = indice;
	  num_nodos_patch[cuenta_nodos_patch].cont = 1;
	  num_nodos_patch[cuenta_nodos_patch].next = aux->contador;
	  aux->contador = &num_nodos_patch[cuenta_nodos_patch];
	  ++cuenta_nodos_patch;
          ++suma;
	}
        seguir=0;
      }
      else if(aux->next==0){
	num_patch[cuenta_patch].r = patch->r;
	num_patch[cuenta_patch].g = patch->g;
	num_patch[cuenta_patch].b = patch->b;
	num_nodos_patch[cuenta_nodos_patch].cont = 1;
	num_nodos_patch[cuenta_nodos_patch].imagen = indice;
	num_nodos_patch[cuenta_nodos_patch].next = 0;
	num_patch[cuenta_patch].contador = &num_nodos_patch[cuenta_nodos_patch];
	aux->next = &num_patch[cuenta_patch];
	++cuenta_patch;
	++cuenta_nodos_patch;
        ++suma;
	seguir=0;
      }
      else{
	aux=aux->next;
      }
    }
  }
}

double hash::get_load_factor() const{
  int numElem=0;
  for(int i=0;i<tableSize;++i){
    Patch *aux=table[i];
    while(aux){
      aux=aux->next;
      ++numElem;
    }
  }
  return numElem/tableSize;
}

double hash::get_standard_desviation() const{
  double sum=0.0, sum_total=0.0, factor_de_carga;
  int num;
  factor_de_carga = get_load_factor();
  for(int i=0;i<tableSize;i++){
    num=0;
    sum=0.0;
    Patch *aux;
    aux=table[i];
    while(aux){
      num++;
      aux=aux->next;
    }
    sum= num-factor_de_carga;
    sum=pow(sum, 2);
    sum_total+=sum;
  }
  return sqrt(sum_total/(tableSize-1));
}

void hash::get_histogram(){
  int max=-1, *num_cubetas = new int[tableSize];
  for (int i=0;i<tableSize;i++) num_cubetas[i]=0;
  for(int i=0;i<tableSize;i++){
    Patch *aux=table[i];
    while(aux){
      aux = aux->next;
      num_cubetas[i]++;
    }
    if(num_cubetas[i]>max) max=num_cubetas[i];
  }
  int *histograma = new int[max+1];
  for(int i=0;i<tableSize;i++) histograma[i]=0;
  for(int i=0;i<tableSize;i++) histograma[num_cubetas[i]]++;
  for(int i=0;i<max+1;i++) std::cout << i << " " << histograma[i] << std::endl;
}

inline unsigned int DJBHash(Patch *patch){
  unsigned int hash = 5381;
  hash = ((hash << 5) + hash) + patch->r;
  hash = ((hash << 5) + hash) + patch->g;
  hash = ((hash << 5) + hash) + patch->b;
  return hash;
}
